#ifndef REPLY_H
#define REPLY_H

#include "resultset.h"
#include "error.h"

struct IHdReply;
struct IHdReplyInfo;

class ReplySink;

class Reply : public SupportsErrorInfo
{
friend ReplySink;

public:
    Reply(IHdReply* pReply=0);
    Reply(const Reply&);
    virtual ~Reply();

    Reply& operator=(const Reply& rhs);
    ResultSet operator[](unsigned long index);

    long Count() const;
    long Value() const;
    typedef enum {REDEEMABLE=1, PROCESSING=2, ABORTED=3} Status;
    Status getStatus() const;

    VARIANT getReplyInfo( const BSTR &bsName) const;
        // Returns the reply info for the given name
    bool Reply::getReplyInfo( int nIndex, BSTR *pName) const;
        // Returns the name at the given index (1-based!)

protected:
    virtual void getErrorInfoParams( IUnknown *&pUnk, const IID *&riid) const;
    virtual void replyComplete(long value) {}

private:
    void setReply(IHdReply* pReply);

    IHdReply *pReply_;
    IHdReplyInfo *pReplyInfo_;

    friend class Request;
};

#endif
